package com.schisandra.oss.application.controller;

import com.alibaba.fastjson.JSON;
import com.google.common.base.Preconditions;
import com.schisandra.oss.application.convert.SchisandraOssFtpDTOConverter;
import com.schisandra.oss.application.dto.SchisandraOssFtpDTO;
import com.schisandra.oss.common.entity.Result;
import com.schisandra.oss.domain.bo.SchisandraOssFtpBO;
import com.schisandra.oss.domain.service.SchisandraOssFtpDomainService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * ftp存储配置表 controller
 *
 * @author landaiqing
 * @since 2024-06-02 21:54:20
 */
@RestController
@RequestMapping("/oss/ftp/")
@Slf4j
public class SchisandraOssFtpController {

    @Resource
    private SchisandraOssFtpDomainService schisandraOssFtpDomainService;

    /**
     * 新增ftp存储配置表
     */
    @RequestMapping("add")
    public Result<Boolean> add(@RequestBody SchisandraOssFtpDTO schisandraOssFtpDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssFtpController.add.dto:{}", JSON.toJSONString(schisandraOssFtpDTO));
            }
            Preconditions.checkNotNull(schisandraOssFtpDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getHost(), "主机不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getPort(), "端口不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getUser(), "用户名不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getPassword(), "密码不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getCharset(), "编码不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getMode(), "FTP连接模式,默认被动不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getBackToPwd(), "设置执行完操作是否返回当前目录,默认false不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getConnectionTimeout(), "连接超时时长，单位毫秒不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getSoTimeout(), "Socket连接超时时长，单位毫秒不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getServerLanguageCode(), "设置服务器语言不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getSystemKey(), "设置服务器系统关键词不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getExtraJson(), "额外字段不能为空");
            SchisandraOssFtpBO SchisandraOssFtpBO = SchisandraOssFtpDTOConverter.INSTANCE.convertDTOToBO(schisandraOssFtpDTO);
            return Result.ok(schisandraOssFtpDomainService.add(SchisandraOssFtpBO));
        } catch (Exception e) {
            log.error("SchisandraOssFtpController.register.error:{}", e.getMessage(), e);
            return Result.fail("新增ftp存储配置表失败");
        }

    }

    /**
     * 修改ftp存储配置表
     */
    @RequestMapping("update")
    public Result<Boolean> update(@RequestBody SchisandraOssFtpDTO schisandraOssFtpDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssFtpController.update.dto:{}", JSON.toJSONString(schisandraOssFtpDTO));
            }
            Preconditions.checkNotNull(schisandraOssFtpDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getHost(), "主机不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getPort(), "端口不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getUser(), "用户名不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getPassword(), "密码不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getCharset(), "编码不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getMode(), "FTP连接模式,默认被动不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getBackToPwd(), "设置执行完操作是否返回当前目录,默认false不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getConnectionTimeout(), "连接超时时长，单位毫秒不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getSoTimeout(), "Socket连接超时时长，单位毫秒不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getServerLanguageCode(), "设置服务器语言不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getSystemKey(), "设置服务器系统关键词不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getExtraJson(), "额外字段不能为空");
            SchisandraOssFtpBO schisandraOssFtpBO = SchisandraOssFtpDTOConverter.INSTANCE.convertDTOToBO(schisandraOssFtpDTO);
            return Result.ok(schisandraOssFtpDomainService.update(schisandraOssFtpBO));
        } catch (Exception e) {
            log.error("SchisandraOssFtpController.update.error:{}", e.getMessage(), e);
            return Result.fail("更新ftp存储配置表信息失败");
        }

    }

    /**
     * 删除ftp存储配置表
     */
    @RequestMapping("delete")
    public Result<Boolean> delete(@RequestBody SchisandraOssFtpDTO schisandraOssFtpDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssFtpController.delete.dto:{}", JSON.toJSONString(schisandraOssFtpDTO));
            }
            Preconditions.checkNotNull(schisandraOssFtpDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getHost(), "主机不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getPort(), "端口不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getUser(), "用户名不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getPassword(), "密码不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getCharset(), "编码不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getMode(), "FTP连接模式,默认被动不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getBackToPwd(), "设置执行完操作是否返回当前目录,默认false不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getConnectionTimeout(), "连接超时时长，单位毫秒不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getSoTimeout(), "Socket连接超时时长，单位毫秒不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getServerLanguageCode(), "设置服务器语言不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getSystemKey(), "设置服务器系统关键词不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssFtpDTO.getExtraJson(), "额外字段不能为空");
            SchisandraOssFtpBO schisandraOssFtpBO = SchisandraOssFtpDTOConverter.INSTANCE.convertDTOToBO(schisandraOssFtpDTO);
            return Result.ok(schisandraOssFtpDomainService.delete(schisandraOssFtpBO));
        } catch (Exception e) {
            log.error("SchisandraOssFtpController.delete.error:{}", e.getMessage(), e);
            return Result.fail("删除ftp存储配置表信息失败");
        }

    }

}
